<? /*************************************************************************************************
Copyright (c) 2003, 2004 Nathan 'Random' Rini
This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*************************************************************************************************/
/**
* Forum Interface Class
*
*/

  class forum {
   var $db; //forum db
   var $users; //users to be updated
   var $enabled = true; //if forum is activated or not

   function forum(){
    //does nothing
   }

   //clean up db
   function cleanup(){if(!$this->enabled) return;
    if(is_object($this->db)) $this->db->cleanup();
   }

//-----------------------------------------------------------------------------------------------------------------------------------------
//Local Cmds
//-----------------------------------------------------------------------------------------------------------------------------------------

  //Will forcefully reload whole forum db
  function force_reload(){global $users; if(!$this->enabled) return;
   $query = new db_cmd("SELECT", "users", "userid", "1");

   foreach($query->data as $data)
    $this->add_user($users->user($data["userid"]), 1);
  }

   //adds user to array of users to be updated
   function add_user(&$user, $create = FALSE, $admin = FALSE){if(!$this->enabled) return;
    if($user->id > 0){ //make copy of user since it wont exist later
     $this->users[$user->id]["create"] = $create;
     $this->users[$user->id]["user"]   = $user;
     $this->users[$user->id]["admin"]  = $admin;
    }
   }

   //run through and update all users
   function update(){if(!$this->enabled) return;
    if(is_array($this->users)){
     if(!empty($this->users)) $this->load_db();

     foreach($this->users as $fuser){
      if($fuser["create"]) $this->create_user($fuser["user"]);

      $this->update_user($fuser["user"], $fuser["admin"]);
    }}
   }

//-----------------------------------------------------------------------------------------------------------------------------------------
//Foreign DB CMDS
//-----------------------------------------------------------------------------------------------------------------------------------------

   //load db class
   function load_db(){global $DB_FORUM_NAME, $DB_FORUM_SERVERHOST, $DB_FORUM_USERNAME, $DB_FORUM_PASSWORD;

    if(!$this->enabled) return;

    $this->db = new db_querys($DB_FORUM_NAME, $DB_FORUM_SERVERHOST, $DB_FORUM_USERNAME, $DB_FORUM_PASSWORD);
   }

   //creates user in forum
   function create_user($fuser){if(!$this->enabled) return;
    //delete copies
    $this->db->query("DELETE FROM `".$GLOBALS["forum_prefix"]."users` WHERE `user_id` = '".$fuser->id."'");

    //add user
    $this->db->query("INSERT INTO `".$GLOBALS["forum_prefix"]."users` (`user_id`, `user_regdate`) VALUES (".$fuser->id.", ".time().")");

   }

   //update user info in forum
    //basicly just force overwrite everything you can find
   function update_user($fuser, $admin = FALSE){if(!$this->enabled) return;
     $items = array(
      "user_active"   => "1",
      "username"      => $fuser->get("name"),
      "user_password" => $fuser->get("password"), //md5
      "user_email"    => $fuser->get("email"),
      "user_regdate"  => time(),
      "user_style"    => "1",
      "user_lang"     => "english",
      "user_rank"     => "0",
     );

     if($admin) //add user as god admin
      $items[] = array("user_level" => 1);

    //compile items
    foreach($items as $key => $val)
     if($key != ''){
      if(gettype($key) != 'integer') $itemlst .= ($itemlst!=''?", ":'') . $key . "=\"" . convertsqlquotes($val) . "\"";
      else $itemlst .= ($itemlst!=''?", ":'') . $val;
     }

    $this->db->query("UPDATE `".$GLOBALS["forum_prefix"]."users` SET ".$itemlst." WHERE `user_id` = '".$fuser->id."'");
   }

//-----------------------------------------------------------------------------------------------------------------------------------------
//News CMDS
//-----------------------------------------------------------------------------------------------------------------------------------------

   //grabs the first post of the latest posts from the first forum
   function fetch_news(){if(!$this->enabled) return;
    //load db if not loaded
    if(!is_object($this->db)) $this->load_db();

    //create news object
    $news = new news();

    //grab ids of all posts
    $query =& $this->db->query("SELECT `post_id`, `topic_id` FROM `".$GLOBALS["forum_prefix"]."posts` WHERE `forum_id` = '".$GLOBALS["forum_news"]."' ORDER BY `post_id` ASC");

    //load all
    $query->load();

    $topics = array(); //declare to stop any errors

    //load everything into an array
    if(is_array($query->db_data))
     foreach($query->db_data as $data) if(!empty($data)) //valid data
      if(!in_array($data["topic_id"], $topics)) //Only have 1 topic - no sub topic shit
       if(++$c < $GLOBALS["news_count"]){ //dont go over limit

       $topics[] = $data["topic_id"];

       //grab forum text and title
       $query_text =& $this->db->query("SELECT `post_subject`, `post_text` FROM `".$GLOBALS["forum_prefix"]."posts_text` WHERE `post_id` = '".$data["post_id"]."' LIMIT 1");

       //load all
       $query_text->load();

       //notify news obj
       $news->add_news($data["post_id"], $query_text->db_data[0]["post_subject"], $query_text->db_data[0]["post_text"]);
     }

    //save!
    $news->generate();

    unset($news);
   }

  }

?>