<? /*************************************************************************************************
Copyright (c) 2003, 2004 Nathan 'Random' Rini
This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*************************************************************************************************/
 /*
  Image DB Protocol
 */

 class db_images {
  var $images; //image array - holds reference to images

  //save all changes to db
  function update_db(){
   if(!empty($this->images))
    foreach($this->images as $image)
     if(!empty($image->data_mod) && $image->id > 0)
      new db_cmd("UPDATE", "images", $image->data_mod, "id='".$image->id."'", 1);
  }

  //retrieve a image
  function &image($id = 0, $create = 0){
   if(!empty($this->images[$id])) return $this->images[$id];
   else {
    if(!($id > 0) && $create) $id = $this->create();
    return $this->images[$id] = new db_image($id);
  }}

  //find user
  function &find_image($name){
   $query = new db_cmd("select", "images", "id", "name LIKE '%".$name."%'", 1);

   return $this->image($query->data[0]["id"]);
  }

  //create new user and then query it
  function create(){
   //grab next id
   $id = $GLOBALS["querys"]->nextid("images", "id");

   //create entry
   new db_cmd("insert", "images", array("id" => $id));

   return $id;
  }

  //loads up the picture - (redirects to picture file)
  function load($id){
   if(is_numeric($id)) //index id
    $image = $this->image($id);
   else //name
    $image = $this->find_image($id);

   if($image->id > 0 && $id != ''){ //image is in db - should exist
    //redirect to correct location in image db
    header( "Location: " . $GLOBALS["loc_images"] . $image->file_name() );

    //update hit count
    $image->set("hits", $image->get("hits") + 1);
   }else //bad image
    header( "Location: ".$GLOBALS["loc_images_default"] ); //send default err
  }
 }

 class db_image {
  var $id;       //image id
  var $data;     //image data
  var $data_mod; //modified image data - not binary source

  function db_image($id = 0){
   $this->id = $id;

   if(!($id > 0)) return; //dont query if not above 0

   $query = new db_cmd("select", "images", "*", "id='".$this->id."'", 1);
   $this->data = & $query->query->db_data[0]; //reference all image info

   $this->id = $this->get("id");
  }

  function delete(){
   new db_cmd("delete", "images", "", "id = ".$this->id);

   //del image
   file_del($this->file_name());

   $this->id = 0;
   $this->data = '';
   $this->data_mod = '';
  }

  function get($name){
   return $this->data[$name];
  }

  function set($name = '', $value = ''){
   if(is_array($name))
    foreach($name as $key => $data)
     $this->data_mod[$key] = $this->data[$key] = $data;
   else if($name != '')
    $this->data_mod[$name] = $this->data[$name] = $value;
  }

  //retrieves file name
  function file_name(){
   return $this->id . "." . $this->get("type");
  }

  //files name from user
  function name(){
   return $this->get("name");
  }

  //file's name picture.php?id=#
  function image(){
   return "picture.php?id=" . $this->id;
  }

  //file hits
  function hits(){
   return $this->get("hits");
  }

  //upload picture to db/save to file
   //$obj  = class file_uploaded
   //$name = optional override
  //return error codes
   // 1 - image isnt in db
   // 2 - bad upload file
   // 3 - not a image
   // 4 - empty image
  function upload($file, $name = ''){
   if(!($this->id > 0)) return 1; //cant save if this doesnt exist
   if($file->err)       return 2; //dont try to save with errors

   if($file->type[0] != "image") return 3; //only images allowed

   //load file into $data
   if(($data = $file->get()) == '') return 4; //empty image

   //del the image your overwriting
   file_del($this->file_name());

   $this->set(array(
     "name" => htmlchars( $name == '' ? $file->obj['name'] : $name ),
     "hits" => 0,
     "type" => $file->type[count($file->type) - 1], //get the files .type
     "size" => $file->obj['size']
    ));

   //save - should add size restrictions
   file_save($this->file_name(), $data);
  }
 }


 /*
  function scale_to_height ($filename, $targetheight) {
   $size = getimagesize($filename);
   $targetwidth = $targetheight * ($size[0] / $size[1]);
   return $targetwidth;
}

function scale_to_width ($filename, $targetwidth) {
   $size = getimagesize($filename);
   $targetheight = $targetwidth * ($size[1] / $size[0]);
   return $targetheight;
} */
?>