<? /*************************************************************************************************
Copyright (c) 2003, 2004 Nathan 'Random' Rini
This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*************************************************************************************************/
 /*
  Tournament Match Class
 */

 //MATCH status List
 $GLOBALS["MATCH_STATUS"]["Winner"]    = 3;
 $GLOBALS["MATCH_STATUS"]["Loser"]     = 2;
 $GLOBALS["MATCH_STATUS"]["Forfeit"]   = 1;
 $GLOBALS["MATCH_STATUS"]["Undecided"] = 0;

 //special bounds check for status
 $GLOBALS["MATCH_STATUS"]["HBOUND"] = 3;
 $GLOBALS["MATCH_STATUS"]["LBOUND"] = 0;

 /*
  is reference to match for results of a match
  reserved use: within tourny match class for routing
 */
 class db_tourny_match_result_pos {
  var $match  = 0; //match id
  var $team   = 0; //team position

  var $or     = 0; //override to put in only one of the $or positions

  function db_tourny_match_result_pos($match, $team, $or = FALSE){
   $this->match = $match;
   $this->team  = $team;
   $this->or    = $or;
  }
 }

 class db_tourny_match {
  var $id       = 0;  //match id
  var $table    = ''; //table name
  var $data;          //data
  var $data_mod;      //data modified
  var $module;        //owner module reference

  var $routes   = array(); //routes array
  var $maps;               //map array
  var $sides;              //side array

  var $route_types = array( //list of possible match outcomes for each team
    "Winner"    => 0,
    "Loser"     => 1,
    "Tie"       => 2,
    "Forfeit"   => 3,
    "Cancelled" => 4
   );

  function db_tourny_match($table, $matchid, $data = FALSE){
   $this->id       = $matchid;
   $this->table    = $table;

   if(!$this->id > 0) return; //not valid

   if($data === FALSE){ //normal db querys
    $query = new db_cmd("select", $table, "*", "id='".$this->id."'", 1);
    $this->data = & $query->query->db_data[0]; //reference all match info
   }else //override db query
    $this->data = $data;

   $this->id = $this->get("id");
  }

  function get($name){
   return $this->data[$name];
  }

  function set($name, $value = '', $filter = false){
   if(is_array($name)) //loop any arrays
    foreach($name as $key => $data)
     $this->set($key, $data, $filter);
   else{
    if($filter){//control the input
     if(strlen($val) > 250) $val = substr($val, 0, 250);

     //remove annoying new lines
     $val = str_replace(array("\n", "<br>", "\r"), '', $val);
    }

    if($name != '') $this->data_mod[$name] = $this->data[$name] = $value;
   }
  }

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/// Module Code
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

  //refernce owner module
  function &module(){global $tourny;
   if(isset($module)) return $this->module;
   else return $this->module =& $tourny->module($this->get("moduleid"));
  }

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/// Routes Code
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

  //load all the team routes or just one
  function &routes(){
   if(!empty($this->routes)) return $this->routes;

   //create blank template of the route types
   for($r=0;$r < count($this->route_types);$r++)
    $template[$r] = array();

   //call to reference owner module
   $this->module();

   //run through each team
   for($t=0;$t < $this->module->get("teamspermatch");$t++){
    //grab routes from table
    $team_routes = unserialize($this->get_team($t, "routes"));

    //fill with route types if not set
    if(empty($team_routes))
     $team_routes = $template;

    //add to master array
    $this->routes[$t] = $team_routes;
   }

   return $this->routes;
  }

  //save route array for db update
  function save_routes(){
   //call to reference owner module
   $this->module();

   if(!empty($this->routes)) //dont waste on blanks
    for($t=0;$t < $this->module->get("teamspermatch");$t++) //run through each team
     if(!empty($this->routes[$t])) //dont waste on blanks
      $this->set_team($t, "routes", serialize($this->routes[$t]));
  }

  //set/add match routes for action types
  function set_route($type, $team, $matchs){
   $this->routes(); //make sure its loaded

   if(is_array($matchs)) //run through array
    foreach($matchs as $match) $this->set_route($type, $team, $match);
   else //single match
    if(!$this->get_route($type, $team, $matchs)) //make sure there are no dubs
     $this->routes[$team][$type][] = $matchs;
  }

  //retrieve route array or find if route is in array
  function get_route($type, $team, $match = FALSE){
   $this->routes(); //make sure its loaded

   if($match){ //check if match is already declared in array
    if(is_array($this->routes[$team][$type]) && !empty($this->routes[$team][$type]))
     //return in_array($match, $this->routes[$team][$type]);
     for($i=0;$i < count($this->routes[$team][$type]);$i++)
      if($this->routes[$team][$type][$i] == $match) return TRUE;
    //default false
    return FALSE;
   }

   return $this->routes[$team][$type];
  }

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/// Teams Code
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

  //special set function to set items for each
  function set_team($team, $item, $val = '', $filter = false){
   if(is_array($item)){ //save array values
    foreach($item as $key => $val)
     $this->set_team($team, $key, $val);

    return;
   }

   if($filter){//control the input
    if(strlen($val) > 250) $val = substr($val, 0, 250);

    //remove annoying new lines
    $val = str_replace(array("\n", "<br>", "\r"), '', $val);
   }

   if($item == 'id' || $item == '') //override for id
    $this->set("team_".$team, $val);
   else //save all sub items
    $this->set("team_".$team."_".$item, $val);
  }

  //special get function to get data for a team
  function get_team($team, $item = ''){
   if($item == '' || $item == "id") return $this->get("team_".$team);
   else return $this->get("team_".$team."_".$item);
  }

  //grab array of all the teams
  function teams(){
   //grab tpm
   $module =& $this->module();
    $tpm = $module->tpm();
   unset($module);

   for($i=0;$i < $tpm;$i++)
    if($this->get_team($i) > 0) $teams[] = $this->get_team($i);

   return $teams;
  }

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/// Maps Code
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  //get map array
  function maps(){
   if(!empty($this->maps)) return $this->maps;

   $this->maps = unserialize($this->get("maps"));

   //create map array if empty
   if(empty($this->maps) && !is_array($this->maps)){
    $module =& $this->module();
    $mpm    = $module->get("mapspermatch");
    unset($module);

    for($i=0;$i < $mpm;$i++)
     $this->maps[$i] = '';
   }

   return $this->maps;
  }

  //save map array
  function save_maps(){
   $this->set("maps", serialize($this->maps()));
  }

  function get_map($id){
   $this->maps(); //make sure maps are loaded

   $module =& $this->module();
   $mpm    = $module->get("mapspermatch");
   unset($module);

   if($id >= 0 && $id < $mpm) //make sure its valid
    return $this->maps[$id];
  }

  function set_map($id, $val = FALSE, $filter = FALSE){
   if(is_array($id)){ //handle any arrays
    foreach($id as $key => $val)
     $this->set_map($key, $val);

    return;
   }

   $this->maps(); //make sure maps are loaded

   //grab mpm
   $module =& $this->module();
   $mpm    = $module->get("mapspermatch");
   unset($module);

   if($filter){//control the input
    if(strlen($val) > 250) $val = substr($val, 0, 250);

    //remove annoying new lines
    $val = str_replace(array("\n", "<br>", "\r"), '', $val);
   }

   if($id >= 0 && $id < $mpm) //make sure its valid
    $this->maps[$id] = $val;
  }
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/// Score Code
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  //get score array
  function scores(){
   if(!empty($this->scores)) return $this->scores;

   $module =& $this->module();
   $mpm    = $module->get("mapspermatch");
   $tpm    = $module->tpm();
   unset($module);

   //grab all the scores
   for($t=0;$t < $tpm;$t++)
    $this->scores[$t] = unserialize($this->get_team($t, "score"));

   //create map array if empty
   if(empty($this->scores) && !is_array($this->scores))
    for($t=0;$t < $tpm;$t++)
     for($m=0;$m < $mpm;$m++)
      $this->scores[$t][$m] = 0;

   return $this->scores;
  }

  //save score array
  function save_scores(){
   $module =& $this->module();
   $tpm    = $module->tpm();
   unset($module);

   for($t=0;$t < $tpm;$t++) //save each score score
    $this->set_team($t, "score", serialize($this->scores[$t]));
  }

  function get_score($id, $map){
   $this->scores(); //make sure scores are loaded

   $module =& $this->module();
   $mpm    = $module->get("mapspermatch");
   $tpm    = $module->tpm();
   unset($module);

   if($id >= 0 && $id < $tpm) //make sure its valid
    if($map >= 0 && $map < $mpm) //valid map
     return (INT) $this->scores[$id][$map];
  }

  function set_score($id, $map, $val){
   $this->scores(); //make sure scores are loaded

   //grab mpm
   $module =& $this->module();
   $mpm    = $module->get("mapspermatch");
   $tpm    = $module->tpm();
   unset($module);

   if($id >= 0 && $id < $tpm) //valid team
    if($map >= 0 && $map < $mpm) //assign single by map
     $this->scores[$id][$map] = (INT) $val;
  }
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/// Eof
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

 }

?>