<? /*************************************************************************************************
Copyright (c) 2003, 2004 Nathan 'Random' Rini
This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*************************************************************************************************/
 /*
  Tournament Module Class
 */

 //Global declartions of module class types
 $GLOBALS["tourny_module"][1]["class"] = "module_elim_bracket_single";
  $GLOBALS["tourny_module"][1]["name"]  = "Single Elimination";
  $GLOBALS["tourny_module"][1]["func"]["presetup"]  = "write_presetup_module_single_elim";
  require_once('./code/class/modules/elimination/bracket_single.inc.php');

 $GLOBALS["tourny_module"][2]["class"] = "module_elim_bracket_double";
  $GLOBALS["tourny_module"][2]["name"]  = "Double Elimination";
  $GLOBALS["tourny_module"][2]["func"]["presetup"]  = "write_presetup_module_double_elim";
  require_once('./code/class/modules/elimination/bracket_double.inc.php');

/* not done yet
 $GLOBALS["tourny_module"][3]["class"] = "module_qualifing";
  $GLOBALS["tourny_module"][3]["name"]  = "Qualifing";
  $GLOBALS["tourny_module"][3]["func"]["presetup"]  = "write_presetup_module_qualifing";
  require_once('./code/class/modules/qualifing.inc.php');
*/

 class db_tourny_module {
  var $id       = 0;  //module id
  var $data     = array(); //data

  var $matchs;  //array of all match ids

  function db_tourny_module($id){
   $this->id = $id;

   if(!($this->id > 0)) return; //not valid

   $query = new db_cmd("select", "tournaments_module", "*", "id='".$this->id."'", 1);
   $this->data = & $query->query->db_data[0]; //reference all user info

   $this->id  = $this->get("id");
  }

  function set($name = '', $value = ''){
   if(is_array($name))
    foreach($name as $key => $data)
     $this->data_mod[$key] = $this->data[$key] = $data;
   else if($name != '')
    $this->data_mod[$name] = $this->data[$name] = $value;
  }

  function get($name){
   return $this->data[$name];
  }

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/// Quick Info Functions
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

  function tpm(){
   return $this->get("teamspermatch");
  }

  function type(){
   return $this->get("type");
  }

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/// Match Code
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

  //grab array of all matchs
   //$load - load data from sql?
   //$ref  - make reference array?
   //$queryid - query for ids of round or just use already loaded ones and search them
  function &matchs($round = -1, $load = TRUE, $ref = FALSE, $queryid = FALSE){global $tourny;
   if(isset($this->matchs[$round][$ref])) return $this->matchs[$round][$ref]; //no dubs

   $matchs = $tourny->find_matchs($this->id, $round, $load, $queryid);

   if(!empty($matchs) && is_array($matchs))
    foreach($matchs as $matchid)
     if($matchid > 0){
      $this->matchs[$round][$ref][$matchid]         =& $tourny->match($matchid);
      if($ref) $this->matchs[$round][$ref]["ref"][] =& $this->matchs[$round][$ref][$matchid];
     }

   return $this->matchs[$round][$ref];
  }

  //Undo moveing teams to next match
  function move_back_match(&$match){global $tourny;
   if(!is_object($match)) $match =& $tourny->match($match);

   //all team routes
   $routes = $match->routes();

   //teams per match
   $tpm = $this->tpm();

   for($t=0;$t < $tpm;$t++){ //run through each team
    //grab team route
    $route = $routes[$t];
    //grab correct route type
    $match->get_team($t, "status");
    //grab correct route
    $mroute = $route[$this->convert_route_type($match->route_types, $match->get_team($t, "status"))];

    if(is_array($mroute)) //valid route
     foreach($mroute as $routeobj) //run through each
      if(is_object($routeobj)) //should be valid
       if($routeobj->match > 0){ //valid next match
        $nmatch =& $tourny->match($routeobj->match);

        if($nmatch->id > 0){ //valid next match
         if($nmatch->get_team($routeobj->team) == $match->get_team($t)) //check if correct team is set
          $nmatch->set_team($routeobj->team, "id", 0);
       }}
   }
  }

  //Move to Teams to Next Round
  function move_next_match(&$match){global $tourny;
   if(!is_object($match)) $match =& $tourny->match($match);

   //all team routes
   $routes = $match->routes();

   //teams per match
   $tpm = $this->tpm();

   for($t=0;$t < $tpm;$t++){ //run through each team
    //grab team route
    $route = $routes[$t];
    //grab correct route type
    $match->get_team($t, "status");
    //grab correct route
    $mroute = $route[$this->convert_route_type($match->route_types, $match->get_team($t, "status"))];
    //default or used
    $or_used = false;

    if(is_array($mroute)) //valid route
     foreach($mroute as $routeobj) //run through each
      if(is_object($routeobj)) //should be valid
       if($routeobj->match > 0){ //valid next match
        $nmatch =& $tourny->match($routeobj->match);

        if($nmatch->id > 0){ //valid next match
         if($routeobj->or){
          if(!($nmatch->get_team($routeobj->team) > 0) && !$or_used){ //dont replace
           $nmatch->set_team($routeobj->team, "id", $match->get_team($t));
           $or_used = true;
          }
         }else //save to new position
          $nmatch->set_team($routeobj->team, "id", $match->get_team($t));
       }}
   }
  }

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/// Round Code
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

  //Checks to determine if all matchs in current round have finished
   //if they are, it will up round and assign all servers
  function check_round(){
   $round = $this->get("round");

   //grab matchs
   $matchs =& $this->matchs($round, false, true, false);

   //grab ref array
   $matchs =& $matchs["ref"];
   $matchs_hbound = count($matchs);

   $same = false; //if all decided

   for($i=0;$i < $matchs_hbound;$i++)
    //check for any nondecided matchs
    if(!(BOOL) $matchs[$i]->get("decided")) $same = true;

   if(!$same && $matchs_hbound > 0){ //next round
    $this->set("round", $round + 1);
    $this->assign_servers_round($round + 1);
   }
  }

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/// Server Code
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

  //Assigns Servers to a whole round
  function assign_servers_round($round){global $tourny, $servers;
   //grab tourny servers
   $tservers = $tourny->servers();

   $tservers_hbound = count($tservers);
   $s = 0; //server index

   //grab matchs
   $matchs =& $this->matchs($round, false, true, false);

   //grab ref array
   $matchs =& $matchs["ref"];
   $matchs_hbound = count($matchs);

   for($i=0;$i < $matchs_hbound ;$i++)
    if(!$matchs[$i]->get("server") > 0) //make sure not to overwrite
     if(!(BOOL) $matchs[$i]->get("decided")){ //dont curropt set matchs
      if($s == $tservers_hbound) $s = 0; //cycle through servers

      //assign server
      $matchs[$i]->set("server", $tservers[$s]);

      $s++;
     }

  }

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/// EOF
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
 }
?>